#include "assert.h"
#include <klee/klee.h>

/*******************************************
* 
* Example code of
* {KLEE:} Unassisted and Automatic Generation of High-Coverage Tests for Complex Systems Programs, OSDI 2008
*
*clang -I ../../include -emit-llvm -c -g eq_check.c
*
*klee --use-query-log=all:smt2 --use-query-log=solver:smt2 --write-smt2s eq_check.bc
*
*klee-stats --print-all klee-last
*
*ktest-tool --write-ints klee-last/test000003.ktest 
******************************************/

unsigned mod_opt(unsigned x, unsigned y) {
	if ((y & -y) == y) {//power of two?
		return x & (y-1);
	}
	else {
		return x % y;
	}
}

unsigned mod(unsigned x, unsigned y) {
	return x % y;
}

int main() {
	unsigned x,y;
	
	klee_make_symbolic(&x, sizeof(x), "x");
	klee_make_symbolic(&y, sizeof(y), "y");
	
	assert(mod(x,y) == mod_opt(x,y));
	
	return 0;
}
